#include <opencv/cv.h>

void DoRotation(CvMat *Src, CvMat *Dst, double roll, double pitch, double yaw){

	//y]
	CvMat *Rot_roll = cvCreateMat(3,3,CV_32FC1);
	cvmSet(Rot_roll,0,0,cos(roll));
	cvmSet(Rot_roll,0,1,-sin(roll));
	cvmSet(Rot_roll,0,2,0);
	cvmSet(Rot_roll,1,0,sin(roll));
	cvmSet(Rot_roll,1,1,cos(roll));
	cvmSet(Rot_roll,1,2,0);
	cvmSet(Rot_roll,2,0,0);
	cvmSet(Rot_roll,2,1,0);
	cvmSet(Rot_roll,2,2,1);

	//x]
	CvMat *Rot_pitch = cvCreateMat(3,3,CV_32FC1);
	cvmSet(Rot_pitch,0,0,cos(pitch));
	cvmSet(Rot_pitch,0,1,0);
	cvmSet(Rot_pitch,0,2,-sin(pitch));
	cvmSet(Rot_pitch,1,0,0);
	cvmSet(Rot_pitch,1,1,1);
	cvmSet(Rot_pitch,1,2,0);
	cvmSet(Rot_pitch,2,0,sin(pitch));
	cvmSet(Rot_pitch,2,1,0);
	cvmSet(Rot_pitch,2,2,cos(pitch));

	//w]
	CvMat *Rot_yaw = cvCreateMat(3,3,CV_32FC1);
	cvmSet(Rot_yaw,0,0,1);
	cvmSet(Rot_yaw,0,1,0);
	cvmSet(Rot_yaw,0,2,0);
	cvmSet(Rot_yaw,1,0,0);
	cvmSet(Rot_yaw,1,1,cos(yaw));
	cvmSet(Rot_yaw,1,2,-sin(yaw));
	cvmSet(Rot_yaw,2,0,0);
	cvmSet(Rot_yaw,2,1,sin(yaw));
	cvmSet(Rot_yaw,2,2,cos(yaw));

	CvMat *Tmp1 = cvCreateMat(3,1,CV_32FC1);
	CvMat *Tmp2 = cvCreateMat(3,1,CV_32FC1);
	
	//w]
	cvmMul(Rot_yaw,Src,Tmp1);
	//x]	
	cvmMul(Rot_pitch,Tmp1,Tmp2);
	//y]	
	cvmMul(Rot_roll,Tmp2,Dst);

}