#include "GraphicsThread.h"

#define _USE_MATH_DEFINES
#include <math.h>
#include <stdlib.h>
#include "GL/glut.h"
#include <GL/freeglut_ext.h>

#include "SharedData.h"
   
#define SQRTOFTWOINV 1.0 / 1.414213562

float sphi=0.0; //90 
float stheta=45.0;
float sdepth = 490.0/4.0; 
float zNear=1.0, zFar=500.0;
float aspect = 5.0/4.0;
long xsize, ysize;
int downX, downY;
bool leftButton = false, middleButton = false;
int i,j;
GLfloat lightPosition[] = { 0.0, 0.0, 1.0, 1.0}; 

void wave(void)
{   
    glutPostRedisplay(); 
}

void write_finger(){
	//w
	float fing_width =  1.0;
	float fing_depth =  2.0;
	float fing_height = 7.0;
	float fing_dist  =  14.0;
	float fing_floor =  0.0;
	float fing_top   =  25.0;
    glColor3f(1.0, 1.0, 1.0);
    glBegin(GL_LINE_STRIP);
		glVertex3f( -fing_depth,   fing_dist,              fing_floor);
		glVertex3f( -fing_depth,   fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   fing_dist,              fing_floor);
		glVertex3f( -fing_depth,   fing_dist,              fing_floor);	
	glEnd();
    glBegin(GL_LINE_STRIP);
		glVertex3f( -fing_depth,   fing_dist,              fing_top);
		glVertex3f( -fing_depth,   fing_dist + fing_width, fing_top);
		glVertex3f(  fing_depth,   fing_dist + fing_width, fing_top);
		glVertex3f(  fing_depth,   fing_dist,              fing_top);
		glVertex3f( -fing_depth,   fing_dist,              fing_top);	
	glEnd();
    glBegin(GL_LINES);
		glVertex3f( -fing_depth,   fing_dist,              fing_top);
		glVertex3f( -fing_depth,   fing_dist,              fing_floor);
		glVertex3f( -fing_depth,   fing_dist + fing_width, fing_top);
		glVertex3f( -fing_depth,   fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   fing_dist + fing_width, fing_top);
		glVertex3f(  fing_depth,   fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   fing_dist,              fing_top);
		glVertex3f(  fing_depth,   fing_dist,              fing_floor);
	glEnd();

    glBegin(GL_LINE_STRIP);
		glVertex3f( -fing_depth,   -fing_dist,              fing_floor);
		glVertex3f( -fing_depth,   -fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   -fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   -fing_dist,              fing_floor);
		glVertex3f( -fing_depth,   -fing_dist,              fing_floor);	
	glEnd();
    glBegin(GL_LINE_STRIP);
		glVertex3f( -fing_depth,   -fing_dist,              fing_top);
		glVertex3f( -fing_depth,   -fing_dist + fing_width, fing_top);
		glVertex3f(  fing_depth,   -fing_dist + fing_width, fing_top);
		glVertex3f(  fing_depth,   -fing_dist,              fing_top);
		glVertex3f( -fing_depth,   -fing_dist,              fing_top);	
	glEnd();
    glBegin(GL_LINES);
		glVertex3f( -fing_depth,   -fing_dist,              fing_top);
		glVertex3f( -fing_depth,   -fing_dist,              fing_floor);
		glVertex3f( -fing_depth,   -fing_dist + fing_width, fing_top);
		glVertex3f( -fing_depth,   -fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   -fing_dist + fing_width, fing_top);
		glVertex3f(  fing_depth,   -fing_dist + fing_width, fing_floor);
		glVertex3f(  fing_depth,   -fing_dist,              fing_top);
		glVertex3f(  fing_depth,   -fing_dist,              fing_floor);
	glEnd();
}

//ŎɏĂ
void drawWireframe(void)
{

	write_finger();	
	glColor3f(1.0, 1.0, 0.0);
 	glPointSize(5.0); 

	//f[^_@	
	data_point.lock();
	glBegin(GL_POINTS); {
		for(j=0;j<data_point.num;j++){
			glVertex3f(data_point.x[j], data_point.y[j], data_point.z[j]);
		}
	} glEnd();
	data_point.unlock();
     
	//f\
	model_point.lock();
    glColor3f(0.0, 0.0, 1.0);
	glBegin(GL_POINTS); {
		for(j=0;j<model_point.num;j++) {
	        glVertex3f( model_point.x[j], model_point.y[j], model_point.z[j]);
		}
	} glEnd();
 
	//fdS\
    glColor3f(1.0, 0.0, 0.0);
	glBegin(GL_POINTS); {
		glVertex3f(model_point.gravi[0], model_point.gravi[1], model_point.gravi[2]);
	} glEnd();
	

	//\
	for(i=0;i<3;i++)
	{
		glBegin(GL_LINE_STRIP); {
			glVertex3f(model_point.gravi[0], model_point.gravi[1], model_point.gravi[2]);
			glVertex3f(model_point.ref_point[i][0], model_point.ref_point[i][1], model_point.ref_point[i][2]);
		} glEnd();
	}
	model_point.unlock();
}


void reshape(int width, int height)
{
    xsize = width; 
    ysize = height;
    aspect = (float)xsize/(float)ysize;
    glViewport(0, 0, xsize, ysize);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glutPostRedisplay();
}

void display(void) 
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(64.0, aspect, zNear, zFar);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity(); 

    glTranslatef(0.0,0.0,-sdepth);
    glRotatef(-stheta, 1.0, 0.0, 0.0);
    glRotatef(sphi, 0.0, 0.0, 1.0);
    glTranslatef(-24.0, -24.0, 0.0);
 
    drawWireframe(); 
    
    glutSwapBuffers();
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

}
void visibility(int state)
{
    glutIdleFunc(wave);
}
void motion(int x, int y)
{
    if (leftButton)
    {
        sphi += (float)(x - downX) / 4.0;
        stheta += (float)(downY - y) / 4.0;
    }
    if (middleButton)
    {
        sdepth += (float)(downY - y) / 10.0;
    }
    downX = x;
    downY = y;
    glutPostRedisplay();
}
void mouse(int button, int state, int x, int y)
{
    downX = x;
    downY = y;
    leftButton = ((button == GLUT_LEFT_BUTTON) && 
                  (state == GLUT_DOWN));
    middleButton = ((button == GLUT_MIDDLE_BUTTON) && 
                    (state == GLUT_DOWN));
}
void keyboard(unsigned char ch, int x, int y)
{
    switch (ch) 
    {
        case '+': sdepth += 2.0; break;
        case '-': sdepth -= 2.0; break;
    }
    glutPostRedisplay();
}

GraphicsThread::GraphicsThread(void)
: is_init_(false)
{
}

GraphicsThread::~GraphicsThread(void)
{
}

bool GraphicsThread::init()
{
	int argc = 0;
	char **argv = NULL;
	glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(1200, 500);
	glutInitWindowPosition(0,600); 
    glutCreateWindow("Graphics");
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glPolygonOffset(1.0, 1.0);
    glEnable(GL_CULL_FACE);
    glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
    glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT, GL_DIFFUSE);
    glLightfv (GL_LIGHT0, GL_POSITION, lightPosition);
    glEnable(GL_LIGHT0);
	glShadeModel(GL_FLAT); 
    glDisable(GL_LIGHTING);
    glutPostRedisplay();
    glutReshapeFunc(reshape);
    glutDisplayFunc(display);
    glutVisibilityFunc(visibility);
    glutKeyboardFunc(keyboard);
    glutMouseFunc(mouse);
    glutMotionFunc(motion);

	glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_GLUTMAINLOOP_RETURNS);

	this->is_init_ = true;
	return true;
}

void GraphicsThread::finish()
{
	this->is_init_ = false;
}

void GraphicsThread::stop()
{
	if (this->is_init_ == true) glutLeaveMainLoop();
	ThreadBase::stop();
}

void GraphicsThread::run()
{
	glutMainLoop();
}
