#include "icp_func.h"
#include <conio.h>

#include "SharedData.h"

void SetOpenGL_data(DATA_POINT *dset, DATA_POINT *mset, int data_point_num, int model_point_num, DATA_POINT *m_gravi) {
	
	int j ;
	int k = 0;
	//data
	data_point.lock();
	for(j=0; j < data_point_num; j++){
		//if ((dset->pt[i].x ==0) && (dset->pt[i].y == 0)) {continue;}
		data_point.x[j] = (float)dset->pt[k].x;
		data_point.y[j] = (float)dset->pt[k].y;
		data_point.z[j] = (float)dset->pt[k].z;
		k++;
	}
	data_point.unlock();
	
	//model
	k = 0;
	model_point.lock();
	for(j=0; j<model_point_num; j++){
		//if ((mset->pt[i].x ==0) && (mset->pt[i].y == 0)) {continue;}
		model_point.x[j] = (float)mset->pt[j].x;
		model_point.y[j] = (float)mset->pt[j].y;
		model_point.z[j] = (float)mset->pt[j].z;
		k++;
	}

	//model gravi
	model_point.gravi[0] = (float)m_gravi->pt[0].x;
	model_point.gravi[1] = (float)m_gravi->pt[0].y;
	model_point.gravi[2] = (float)m_gravi->pt[0].z;
	//model gravi direction
	model_point.ref_point[0][0] = (float)m_gravi->pt[1].x;
	model_point.ref_point[0][1] = (float)m_gravi->pt[1].y;
	model_point.ref_point[0][2] = (float)m_gravi->pt[1].z;
	model_point.ref_point[1][0] = (float)m_gravi->pt[2].x;
	model_point.ref_point[1][1] = (float)m_gravi->pt[2].y;
	model_point.ref_point[1][2] = (float)m_gravi->pt[2].z;
	model_point.ref_point[2][0] = (float)m_gravi->pt[3].x;
	model_point.ref_point[2][1] = (float)m_gravi->pt[3].y;
	model_point.ref_point[2][2] = (float)m_gravi->pt[3].z;
	model_point.unlock();
}

void Free_Data_Points(DATA_POINT *pset) {
	free(pset->pt);
	free(pset);
}

void PrintPoint3DSet(DATA_POINT *pset) {
	int i;
	for (i=0; i < pset->num; i++) {
		printf("Point #%d (x,y,z,r,theta)=(%f,%f,%f,%f,%f)\n",
		i, pset->pt[i].x, pset->pt[i].y, pset->pt[i].z);
	}
}
void Calc_Nearest_Match(DATA_POINT *sel_real_data, DATA_POINT *model_data, DATA_POINT *ans) {

	int i, j;
	int closest_index = 0;
	double distance = 0;
	double minimum_distance = 0;
	for (i=0; i < sel_real_data->num; i++) {
		closest_index = 0;
		minimum_distance = 1000000000;
		for (j=0; j < model_data->num; j++) {
			if ((model_data->pt[j].x == 0)&&(model_data->pt[j].y == 0)) {continue;}
			distance = (sel_real_data->pt[i].x - model_data->pt[j].x)*(sel_real_data->pt[i].x - model_data->pt[j].x) +
						(sel_real_data->pt[i].y - model_data->pt[j].y)*(sel_real_data->pt[i].y - model_data->pt[j].y) +
						(sel_real_data->pt[i].z - model_data->pt[j].z)*(sel_real_data->pt[i].z - model_data->pt[j].z) ;
			if (distance < minimum_distance) {
				minimum_distance = distance;
				closest_index = j;
			}
		}
		ans->pt[i].x = model_data->pt[closest_index].x;
		ans->pt[i].y = model_data->pt[closest_index].y;
		ans->pt[i].z = model_data->pt[closest_index].z;
	}
}

CvPoint3D64f Calc_Gravity_Point(DATA_POINT *pset) {
	int i;
	CvPoint3D64f p_bar;
	p_bar.x = 0;
	p_bar.y = 0;
	p_bar.z = 0;
	for (i=0; i < pset->num; i++) {
		p_bar.x += pset->pt[i].x;
		p_bar.y += pset->pt[i].y;
		p_bar.z += pset->pt[i].z;
	}
	p_bar.x /= pset->num;
	p_bar.y /= pset->num;
	p_bar.z /= pset->num;

	return p_bar;
}

void PrintPoint3D(CvPoint3D64f p) {
	printf("Point (x,y,z)=(%f,%f,%f)\n", p.x, p.y, p.z);
}

void Disp_Matrix(CvMat *Matrix, int Rows, int Cols) {
	int i, j;
	for(i=0; i<Rows; i++) {
		  for(j=0; j<Cols; j++) { printf("%f ",cvGet2D(Matrix,i,j).val[0]); }
		printf("\n");
	}
	printf("\n");
}
void SetRotationMatrix(CvMat *Matrix, QUATERNION Q) {

	cvmSet(Matrix, 0, 0, Q.q0*Q.q0 + Q.q1*Q.q1 - Q.q2*Q.q2 - Q.q3*Q.q3);
	cvmSet(Matrix, 0, 1, 2*(Q.q1*Q.q2 - Q.q0*Q.q3));
	cvmSet(Matrix, 0, 2, 2*(Q.q1*Q.q3 + Q.q0*Q.q2));
	cvmSet(Matrix, 1, 0, 2*(Q.q2*Q.q1 + Q.q0*Q.q3));
	cvmSet(Matrix, 1, 1, Q.q0*Q.q0 - Q.q1*Q.q1 + Q.q2*Q.q2 - Q.q3*Q.q3);
	cvmSet(Matrix, 1, 2, 2*(Q.q2*Q.q3 - Q.q0*Q.q1));
	cvmSet(Matrix, 2, 0, 2*(Q.q3*Q.q1 - Q.q0*Q.q2));
	cvmSet(Matrix, 2, 1, 2*(Q.q3*Q.q2 + Q.q0*Q.q1));
	cvmSet(Matrix, 2, 2, Q.q0*Q.q0 - Q.q1*Q.q1 - Q.q2*Q.q2 + Q.q3*Q.q3);

}

MOVEMENT Calc_Movements(DATA_POINT *r_data, DATA_POINT *m_data) {

	CvPoint3D64f r_grav, m_grav;
	r_grav = Calc_Gravity_Point(r_data);
	m_grav = Calc_Gravity_Point(m_data);
	
	CvMat *PMAT = cvCreateMat(4,4,CV_64FC1);

	double Sxx=0, Sxy=0, Sxz=0, Syx=0, Syy=0, Syz=0, Szx=0, Szy=0, Szz=0;
	double Mcx, Mcy, Mcz, Dcx, Dcy, Dcz;
	int i;
	for (i=0; i<r_data->num; i++) {
		Mcx = m_data->pt[i].x - m_grav.x;
		Mcy = m_data->pt[i].y - m_grav.y;
		Mcz = m_data->pt[i].z - m_grav.z;
		Dcx = r_data->pt[i].x - r_grav.x;
		Dcy = r_data->pt[i].y - r_grav.y;
		Dcz = r_data->pt[i].z - r_grav.z;
		Sxx += (Dcx*Mcx);
		Sxy += (Dcx*Mcy);
		Sxz += (Dcx*Mcz);
		Syx += (Dcy*Mcx);
		Syy += (Dcy*Mcy);
		Syz += (Dcy*Mcz);
		Szx += (Dcz*Mcx);
		Szy += (Dcz*Mcy);
		Szz += (Dcz*Mcz);
	}

	// Set PMAT 
	cvmSet(PMAT, 0, 0, Sxx + Syy + Szz);
	cvmSet(PMAT, 0, 1, Syz - Szy);
	cvmSet(PMAT, 0, 2, Szx - Sxz);
	cvmSet(PMAT, 0, 3, Sxy - Syx);
	cvmSet(PMAT, 1, 0, Syz - Szy);
	cvmSet(PMAT, 1, 1, Sxx - Syy - Szz);
	cvmSet(PMAT, 1, 2, Sxy + Syx);
	cvmSet(PMAT, 1, 3, Szx + Sxz);
	cvmSet(PMAT, 2, 0, Szx - Sxz);
	cvmSet(PMAT, 2, 1, Sxy + Syx);
	cvmSet(PMAT, 2, 2, Syy - Sxx - Szz);
	cvmSet(PMAT, 2, 3, Syz + Szy);
	cvmSet(PMAT, 3, 0, Sxy - Syx);
	cvmSet(PMAT, 3, 1, Szx + Sxz);
	cvmSet(PMAT, 3, 2, Syz + Szy);
	cvmSet(PMAT, 3, 3, Szz - Sxx - Syy);

	CvMat *eigen_row=cvCreateMat(4,1,CV_64FC1);
	CvMat *eigen_vector=cvCreateMat(4,4,CV_64FC1);
	cvEigenVV(PMAT, eigen_vector, eigen_row, DBL_EPSILON);

	CvMat *R = cvCreateMat(3,3,CV_64FC1);

	double max_eigenvalue = cvGet2D(eigen_row,0,0).val[0];
	int max_eigenvalue_index = 0;
	for (i=0; i<4; i++) {
		if (cvGet2D(eigen_row,i,0).val[0] > max_eigenvalue) {
			max_eigenvalue = cvGet2D(eigen_row,i,0).val[0];
			max_eigenvalue_index = i;
		}
	}

	MOVEMENT MV;
	MV.Q.q0 = cvmGet(eigen_vector,max_eigenvalue_index,0);
	MV.Q.q1 = cvmGet(eigen_vector,max_eigenvalue_index,1);
	MV.Q.q2 = cvmGet(eigen_vector,max_eigenvalue_index,2);
	MV.Q.q3 = cvmGet(eigen_vector,max_eigenvalue_index,3);
	
	SetRotationMatrix(R, MV.Q);
		
	CvMat *T = cvCreateMat(3,1,CV_64FC1);
	CvMat *m_gravi_M = cvCreateMat(3,1,CV_64FC1);
	
	cvmSet(m_gravi_M, 0, 0, m_grav.x);
	cvmSet(m_gravi_M, 1, 0, m_grav.y);
	cvmSet(m_gravi_M, 2, 0, m_grav.z);

	CvMat *r_gravi_M = cvCreateMat(3,1,CV_64FC1);
	
	cvmSet(r_gravi_M, 0, 0, r_grav.x);
	cvmSet(r_gravi_M, 1, 0, r_grav.y);
	cvmSet(r_gravi_M, 2, 0, r_grav.z);
	
	CvMat *Matrix1 = cvCreateMat(3,1,CV_64FC1);
	cvmMul(R, r_gravi_M, Matrix1);
	CvMat *Matrix2 = cvCreateMat(3,1,CV_64FC1);
	cvmSub(m_gravi_M, Matrix1, Matrix2);
	
	MV.Trl.x = cvmGet(Matrix2, 0, 0);
	MV.Trl.y = cvmGet(Matrix2, 1, 0);
	MV.Trl.z = cvmGet(Matrix2, 2, 0);

	cvReleaseMat(&Matrix2);
	cvReleaseMat(&Matrix1);
	cvReleaseMat(&m_gravi_M);
	cvReleaseMat(&r_gravi_M);
	cvReleaseMat(&eigen_row);
	cvReleaseMat(&eigen_vector);
	cvReleaseMat(&T);
	cvReleaseMat(&PMAT);
	cvReleaseMat(&R);

	return MV;
}

void Move_3D_Points(MOVEMENT MV, DATA_POINT *pset) {
	CvMat *R = cvCreateMat(3,3,CV_64FC1);
	CvMat *T = cvCreateMat(3,1,CV_64FC1);
	SetRotationMatrix(R, MV.Q);
	cvmSet(T,0,0,MV.Trl.x);
	cvmSet(T,1,0,MV.Trl.y);
	cvmSet(T,2,0,MV.Trl.z);

	CvMat *point = cvCreateMat(3,1,CV_64FC1);
	CvMat *Matrix1 = cvCreateMat(3,1,CV_64FC1);
	CvMat *Matrix2 = cvCreateMat(3,1,CV_64FC1);
	int i;
	for (i=0; i < pset->num; i++) {
		cvmSet(point,0,0,pset->pt[i].x);
		cvmSet(point,1,0,pset->pt[i].y);
		cvmSet(point,2,0,pset->pt[i].z);
		cvmMul(R, point, Matrix1);
		cvmAdd(Matrix1, T, Matrix2);
		pset->pt[i].x = cvmGet(Matrix2, 0, 0);
		pset->pt[i].y = cvmGet(Matrix2, 1, 0);
		pset->pt[i].z = cvmGet(Matrix2, 2, 0);
	}
	cvReleaseMat(&Matrix2);
	cvReleaseMat(&Matrix1);
	cvReleaseMat(&point);
	cvReleaseMat(&T);
	cvReleaseMat(&R);  
}
void Move_3D_Points2(MOVEMENT MV, DATA_POINT *pset) {
	//ł́Amodel𓮂߂ɁATransformPoint3DSet̋t̏pӂB
	CvMat *R = cvCreateMat(3,3,CV_64FC1);
	CvMat *T = cvCreateMat(3,1,CV_64FC1);
	CvMat *invR = cvCreateMat(3,3,CV_64FC1);
	SetRotationMatrix(R, MV.Q);
	cvInvert(R,invR,CV_LU);
	cvmSet(T,0,0,-MV.Trl.x);
	cvmSet(T,1,0,-MV.Trl.y);
	cvmSet(T,2,0,-MV.Trl.z);

	CvMat *point = cvCreateMat(3,1,CV_64FC1);
	CvMat *Matrix1 = cvCreateMat(3,1,CV_64FC1);
	CvMat *Matrix2 = cvCreateMat(3,1,CV_64FC1);
	int i;
	for (i=0; i < pset->num; i++) {
		cvmSet(point,0,0,pset->pt[i].x);
		cvmSet(point,1,0,pset->pt[i].y);
		cvmSet(point,2,0,pset->pt[i].z);
		cvmMul(invR, point, Matrix1);
		cvmAdd(Matrix1, T, Matrix2);
		pset->pt[i].x = cvmGet(Matrix2, 0, 0);
		pset->pt[i].y = cvmGet(Matrix2, 1, 0);
		pset->pt[i].z = cvmGet(Matrix2, 2, 0);
	}
	cvReleaseMat(&Matrix2);
	cvReleaseMat(&Matrix1);
	cvReleaseMat(&point);
	cvReleaseMat(&T);
	cvReleaseMat(&R); 
}
void OutPutPosture(DATA_POINT *model_gravi, float raw_sum[3])
{
	float ee[3][3];
	float length1;
	int i;
	for(i=0;i<3;i++){
		ee[i][0] = (float)(model_gravi->pt[i+1].x - model_gravi->pt[0].x);
		ee[i][1] = (float)(model_gravi->pt[i+1].y - model_gravi->pt[0].y);
		ee[i][2] = (float)(model_gravi->pt[i+1].z - model_gravi->pt[0].z);	
		length1 = sqrt(ee[i][0]*ee[i][0] + ee[i][1]*ee[i][1] + ee[i][2]*ee[i][2]);
		printf("(%f,%f,%f) %f \n",ee[i][0],ee[i][1],ee[i][2],length1);
	}

	result_data.lock();
	result_data.result[0]  = 0;  // JID
	result_data.result[1]  = 0;  // ̂hc
	result_data.result[2]  = 0;  // ԍ
	result_data.result[3]  = 1;  // Wnԍ
	result_data.result[4]  = 1;  // ʊmx 
	result_data.result[5]  = 0;  // G[ԍ
	result_data.result[6]  = 0;  // \(1)
	result_data.result[7]  = 0;  // \(2)
	result_data.result[8]  = ee[0][0];  // ̂̎p\]s1s1
	result_data.result[9]  = ee[0][1];  // ̂̎p\]s1s2
	result_data.result[10] = ee[0][2];  // ̂̎p\]s1s3
	result_data.result[11] = (float)(model_gravi->pt[0].x + raw_sum[0]);  // ̂̈ʒuxNĝw
	result_data.result[12] = ee[1][0];  // ̂̎p\]s2s1
	result_data.result[13] = ee[1][1];  // ̂̎p\]s2s2
	result_data.result[14] = ee[1][2];  // ̂̎p\]s2s3
	result_data.result[15] = (float)(model_gravi->pt[0].y + raw_sum[1]);  // ̂̈ʒuxNĝx
	result_data.result[16] = ee[2][0];  // ̂̎p\]s3s1
	result_data.result[17] = ee[2][1];  // ̂̎p\]s3s2
	result_data.result[18] = ee[2][2];  // ̂̎p\]s3s3
	result_data.result[19] = (float)(model_gravi->pt[0].z + raw_sum[2]);  // ̂̈ʒuxNĝy
	result_data.unlock();

	printf(
		"gravi (%f,%f,%f)  \n",
		result_data.result[11], 
		result_data.result[15], 
		result_data.result[19]
	);
}

void icp_func(MOVEMENT *delta, DATA_POINT *sel_data_set, DATA_POINT *model_set, DATA_POINT *model_gravi, 
			  int data_point_num, int model_point_num, float raw_sum[3]) {

		
	//ԕ\
	SetOpenGL_data(sel_data_set, model_set, data_point_num, model_point_num, model_gravi);
	
	DATA_POINT *ans; 
	ans = (DATA_POINT*)malloc(sizeof(DATA_POINT));
	ans->num = data_point_num;
	ans->pt = (CvPoint3D64f*)malloc(data_point_num*sizeof(CvPoint3D64f));
	//}b`OJn
	DWORD time0,time1;
	time0 = GetTickCount();
	Calc_Nearest_Match(sel_data_set, model_set , ans);
	
	MOVEMENT MV;
	MV = Calc_Movements(sel_data_set, ans);
	Move_3D_Points2(MV, model_set);
	Move_3D_Points2(MV, model_gravi);
	SetOpenGL_data(sel_data_set, model_set, data_point_num, model_point_num, model_gravi);

	int trancount = 0;

	while (fabs(MV.Trl.x)+fabs(MV.Trl.y)+fabs(MV.Trl.z) > 0.001) {
		Calc_Nearest_Match(sel_data_set, model_set, ans);
		MV = Calc_Movements(sel_data_set, ans);
		
		Move_3D_Points2(MV, model_set);
		Move_3D_Points2(MV, model_gravi);
		
		SetOpenGL_data(sel_data_set, model_set, data_point_num, model_point_num, model_gravi);
		trancount++;
	
	}

	time1 = GetTickCount();
	printf("time=%6g \n", (double)(time1-time0));
	
	OutPutPosture(model_gravi,raw_sum);
		
	Free_Data_Points(ans);

}
